﻿using System;
using System.Text;
using System.IO;
using System.Windows.Forms;

namespace KITTester
{
    public class TextBoxStreamWriter : java.io.StringWriter
    {
        RichTextBox _output = null;
        System.Drawing.Color _color;

        public TextBoxStreamWriter(RichTextBox output, System.Drawing.Color color)
        {
            _output = output;
            _color = color;
        }

        public override void write(String value)
        {
            base.write(value);
            if (!_output.InvokeRequired)
            {
                _output.SelectionColor = _color;
                _output.AppendText(value.ToString());
                _output.AppendText(Environment.NewLine);
            }
            else
            {
                _output.BeginInvoke(new dwrite(_write), value);
            }
        }

        private delegate void dwrite(String value);
        private void _write(String value)
        {
            _output.SelectionColor = _color;
            _output.AppendText(value.ToString());
            _output.AppendText(Environment.NewLine);
        }
    }
}
