﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;
using com.paytec.kit;

namespace KITTester
{

    [Serializable]
    public class TransactionCallbacks : com.paytec.kit.TransactionCallbacks
    {
        Device device;
        
        [NonSerialized]
        frmKITTester owner;

        protected TransactionCallbacks(SerializationInfo info, StreamingContext context)
        { }


        public TransactionCallbacks(frmKITTester owner)
        {
            this.owner = owner;
            this.device = owner.device;
        }

        public override void onCommitResponse(Transaction t)
        {
            this.owner.BeginInvoke(new donCommitResponse(_onCommitResponse), t);
        }
        private delegate void donCommitResponse(Transaction t);
        private void _onCommitResponse(Transaction t)
        {
            Device d = (Device)t.getDevice();
            String keyString = d.getDeviceId() + " - " + t.getTrxSeqCnt();

            owner.transactionList.Remove(keyString);
            owner.rebindTransactionComboBox();
            owner.OutMessages.write("KITTESTER Terminal Response: Transaction commit response");
            owner.OutMessages.write(t.toString());
        }

        public override void onRollbackResponse(Transaction t)
        {
            this.owner.BeginInvoke(new donRollbackResponse(_onRollbackResponse), t);
        }
        private delegate void donRollbackResponse(Transaction t);
        private void _onRollbackResponse(Transaction t)
        {
            owner.OutMessages.write("Terminal Response: Transaction rollback response");
            owner.OutMessages.write(t.toString());
        }

    }
}
